;   |_-_-_-_-_-_-_-_-_-_-_-_-_-_ |
;   $ Prozeduren                 $                                 
;   $(C) by Bluespeed            $
;   $ bluespeedde@yahoo.de       $
;   |_-_-_-_-_-_-_-_-_-_-_-_-_-_ |


;  Hallo und Willkommen zu einem weiteren Teil der PureBasic Tutorials, dieses Mal 
;  wollen wir uns mit den Prozeduren beschftigen. Prozeduren sind ein sehr wichtiger
;  Bestandteil der PureBasic Programmiersprache.
;  Wir wollen nun genauer wissen, wozu sie dienen. Eine Prozedur ist ein abgekapseltes 
;  Unterprogramm, das eine oder mehrere Aufgaben erledigt. Diese Aufgaben knnen von 
;  rechne 1+1 bis zu einer Scroll-Engine und weiter reichen. 
;  Jetzt werdet Ihr Euch sicherlich fragen, wozu eine Prozedur? Kann man das nicht 
;  direkt in der Repeat Schleife eingeben? Sicher kann man das, nur wird dadurch der 
;  Code unbersichtlicher. Ich werde einfach mal ein Beispiel zeigen:

Global ok                            ; Um eine Variable sowohl in der Prozedur als auch im
                                      ; Hauptprogramm nutzen zu knnen, muss man sie erst globalisieren

; DIE ARBEIT DES KERNS
Procedure sag_hallo()                                 ; Eine Prozedur mit dem Namen sag_hallo 
  MessageRequester("Hallo","Hallo ich bin eine Prozedure, die Hallo sagen muss",0)  ; Hier ist der Inhalt der 
                                                       ; Prozedur - wir geben einen Text mit Hallo aus.
  ok = 1                                               ; Wenn Ok im Requester gedrckt wird, erhlt die
                                                       ; Variable den Wert 1.
EndProcedure                                         ; Ende der Prozedur

; DER KERN
Repeat                                                ; Eine schleife, nun fngt der "Kern" des Programms an.
sag_hallo()                                            ; Wir rufen nun die Prozedur sag_hallo() auf.
Until ok = 1                                          ; Wenn ok = 1 ist, endet das Programm.


; So nun stellt Euch doch mal vor, anstatt im Kern den ganzen Code zu schreiben, 
; benutzt man einfach eine Prozedur fr z.B. Bewege_Bild() oder oder Rechne_aus().
; Am Anfang wird immer der Befehl Procedure eingegeben, danach wird der Prozedur-Name 
; definiert. Logischerweise sollte dieser etwas ber die Prozedur aussagen. Wenn ich 
; jetzt in der Prozedur etwas ausrechen mchte, wrde ich sie z.B. Rechne_aus() nennen. 
; Klar kann man sie auch doof() oder hans() nennen, aber was bringt das ;).
; Danach kommen die Klammern, diese darf man nicht vergessen, da sie ein Merkmal von
; Prozeduren sind. Innerhalb der Prozedur kommt dann die Aufgabe, also was soll die 
; Prozedur machen? Rechnen, Bewegen, etwas ausgeben, steuern usw. usw. Das bleibt Euch 
; berlassen. Mit EndProcedure wird das ganze beendet. Nun habt Ihr eine Prozedur, die 
; etwas macht, aber sie wird nicht automatisch ausgefhrt. Wie aktiviere ich sie also?
; Ganz einfach: man gibt den Namen der Prozedur ein, dort wo man sie genau haben 
; mchte - in unserem Falle ist es in der Repeat Schleife. Somit wurde die Prozedur 
; AUFGERUFEN, jetzt wird sie auch ausgefhrt. Wenn man aber eine Prozedur codet und sie 
; nicht aufruft, bleibt sie inaktiv und macht innerhalb des Programms berhaupt nichts.

; So das war's mal wieder. Ich hoffe, dass Ihr die Prozeduren geschickt einsetzt, denn 
; sie knnten Euren Code um einiges bersichtlicher machen.

; CU
; BLUESPEED  


; 05. Juli 2003: berarbeitete Sprache und Layout by Andr Beer - exklusiv fr www.purearea.net

; ExecutableFormat=Windows
; FirstLine=1
; Executable=D:\Numan\Projekte\Tutorials\Tutorial2.exe
; EOF