;   |_-_-_-_-_-_-_-_-_-_-_-_-_-_ |
;   $ Structure                  $                                 
;   $(C) by Bluespeed            $
;   $ bluespeedde@yahoo.de       $
;   |_-_-_-_-_-_-_-_-_-_-_-_-_-_ |



;  Hallo und Willkommen zu einem weiteren Teil der PureBasic Tutorials. Diesmal wollen 
;  wir uns mit den Befehl Structure beschftigten. Wozu dient dieser Befehl? Er dient
;  dazu, einem Objekt Eigenschaften zu verleihen.
;  Ich werde einfach mal anfangen, danach erklre ich es ausfhrlich.

;----------------
; DEFINITION
;------------------
Structure Person                 ; Wir deklarieren eine Struktur mit dem Namen Person.
  Nick.s                          ; Diese Person muss einen Nick haben.
  Name.s                          ; Sie muss auch einen Namen beinhalten.
  Alter.w                         ; Und das Alter wollen wir auch wissen.
EndStructure                    ; Ende der Deklaration


;-----------------
; OBJEKT
;-----------------
Dim Junge.Person(0)                    ; Nun verbinden wir ein "reales Objekt" (Junge)
                                       ; mit der Definition (Person).
Junge(0)\Nick       = "bluespeed"      ; Der Nick des Jungen soll bluespeed lauten,
Junge(0)\Name       = "Numan Ibheis"   ; der Name lautet Numan Ibheis
Junge(0)\Alter      = 16               ; und er ist 16 Jahre alt.



Repeat                                                                     ; Wir starten eine Schleife.
  MessageRequester("Hi","Ich bin "+Junge(0)\Nick,0)                         ; Nun zeigen wir den Nick des Jungen.
  MessageRequester("Name","Mein wirklicher Name lautet "+Junge(0)\Name,0)   ; Auch der Name wird angezeigt.
  MessageRequester("Alter","Ich bin "+Str(Junge(0)\Alter)+" Jahre alt",0)   ; Natrlich darf das Alter nicht fehlen.
  ok = 1                                                                    ; ok = erfolgreich
Until ok = 1                                                               ; Ende, nachdem ok = erfolgreich ist.



; Ok, Ihr werdet jetzt bestimmt sagen, dass dies keinen interessiert, weil man es nicht 
; brauchen wird - "Falsche Antwort".
; Dieser Befehl ist nicht nur sehr ordentlich fr den Code, sondern auch sehr 
; hilfreich. Wofr? 
; Sagen wir mal, Ihr mchtet ein Spiel programmieren und jetzt braucht ihr einen
; Helden. Held? Kommt sofort ;)

;Structure Held
;    Name.s
;    Energie.b
;    Speed.l
;EndStructure

; Es klappt genauso gut mit Aliens, Tieren, Endgegner etc. Auch fr Programme ist 
; Structure sehr hilfreich. Hier ein Beispiel:

;Structure Windows_Fenster
;   Titel.s
;   Hoehe.w
;   Breite.w
;EndStructure

; Man kann wirklich alles mit Structure machen. Und das gute daran ist, man verliert 
; keinen SPEED wie bei BlitzBasic mit Types.
; Diese .s .w .b .l .f sind Typen, die entweder Strings wie "hallo", Fliekomma-Zahlen, 
; ganze Zahlen wie 1,2,3,500,1000 oder auch andere Typen darstellen. Hier mal eine 
; Tabelle aus der Hilfe (F1).


; Name    Erweiterung     Speicherverbrauch               Bereich 
; Byte    .b              1 Byte im Speicher              -128 bis +127 
; Word    .w              2 Byte im Speicher              -32768 bis +32767  
; Long    .l              4 Byte im Speicher              -2147483648 bis +2147483647 
; Float   .f              4 Byte im Speicher              unlimitiert 
; String  .s              Lnge des Strings +1            unlimitiert 

; Die Structure ist so etwas wie eine Vorstellung. Man stellt sich in unseren Falle 
; eine Person vor, die einen Nick, Namen und Alter besitzt. Dann kommt das "reale" 
; Objekt, der Junge. Speicher Junge(Anzahl). Mann kann auch 100 in der Klammer
; eingeben, dann hat man 100 reale Jungs, denen man jeweils einen Nick, Namen und Alter 
; zuweisen kann. Nun geben wir unseren Jungen den Nick, mge sein Nick Bluespeed 
; heien ;), auch ein Name und Alter werden angegeben. Dieses Backslash(\) ist der 
; Zuweisungs-Operator. Dieser muss immer angegeben werden, wenn man einem Objekt etwas 
; zuweisen mchte. Danach schreiben wir das ganze in einem Requester aus.
; Wenn man einen Text und eine Variable gleichzeitig in den Code schreiben mchte, muss 
; man die Gnsefchen wieder zu machen und mit der - mittels Str() in einen String 
; umgewandelten - Variable mit + verbinden. Hier ein Beispiel:

; "Das ist ein Text "+Str(Variable)+" so fgt man die Information einer Variable im 
; Text ein"

; So das war's. Ich hoffe, dass Ihr nun einen etwas besseren Durchblick habt, wenn's um 
; Strukturen geht.


; CU
; BLUESPEED


; 05. Juli 2003: berarbeitete Sprache und Layout by Andr Beer - exklusiv fr www.purearea.net

; ExecutableFormat=Windows
; FirstLine=1
; EOF